## extract the 2000 daily RCM grid to rds ####
# by rcm-gcm (all vars)

# path_in <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/nc/daily/rcm/intercomp-2000/"
# path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/rds/grid/intercomp-2000/"

path_in <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/nc/daily/rcm/intercomp-1971-2000-sub/"
path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/rds/grid/intercomp-1971-2000-sub/"

# -> not working for the 30 years, too much data!

library(eurocordexr)
library(foreach)
library(mitmatmisc)

# init_parallel_ubuntu()


dat_inv <- get_inventory(path_in, add_files = T)
dat_gcmrcm <- unique(dat_inv[, .(gcm, institute_rcm)])


l_null <- foreach(
  i_row = 1:nrow(dat_gcmrcm),
  .inorder = F
) %dopar% {

  dat_gcmrcm[i_row] %>% 
    merge(dat_inv, by = c("gcm", "institute_rcm")) -> dat_inv_i

  all_vars <- unique(dat_inv_i$variable)
  # do not do anything if only 1 snow variable
  if(length(all_vars) == 1) return(NULL)

  dat_full <- foreach(
    i_var = all_vars,
    .final = function(x) Reduce(f = function(x,y) merge(x, y, all = T), x = x)
  ) %do% {
    
    dat_inv_i_var <- dat_inv_i[variable == i_var]

    foreach(
      i_file = dat_inv_i_var[, list_files][[1]],
      .final = rbindlist
    ) %do% {

      dat_nc <- nc_grid_to_dt(i_file, i_var, interpolate_to_standard_calendar = T, verbose = T)
      dat_nc[, gcm := dat_inv_i_var[, gcm]]
      dat_nc[, rcm := dat_inv_i_var[, institute_rcm]]
      dat_nc[, experiment := dat_inv_i_var[, experiment]]
      
      # some have non-standard calendars, but for monthly data does not matter
      dat_nc[, date := ymd(date)]
      
      dat_nc

    }

  }
  
  dat_full_nonna <- na.omit(dat_full)

  # adjust units
  dat_full_nonna[, snc := snc/100]
  
  # file to save
  file_save <- path_out %+%
    dat_gcmrcm[i_row, gcm] %+% "_" %+% dat_gcmrcm[i_row, institute_rcm] %+% ".rds"
  
  saveRDS(dat_full_nonna, file = file_save) 

}






