# use CDO to:
#   crop snow variables (SNC, SNW, SND) to Alps to save space
#
# ------------------------- #

# library(data.table)
library(magrittr)
library(fs)
library(foreach)
# get parallel
library(doParallel)
registerDoParallel(cores = 6)

# cutregion
lon1 <- 0
lon2 <- 20
lat1 <- 40
lat2 <- 55


# path_in <- "/mnt/CEPH_PROJECTS/CLIRSNOW/wget-snow/SND/"
# path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SND/"

f_sellonlat <- function(path_in, path_out){
  
  all_files <- dir_ls(path_in, glob = "*.nc")
  
  foreach(
    i_fn = all_files,
    .inorder = F
    ) %dopar% {
    
      
      in_file <- i_fn
      out_file <- path(path_out,
                       path_file(i_fn))

      
      if(file_exists(out_file)) return(paste0("Skipped: ", out_file))
      
      cdo_call <- paste0("cdo ", "-z zip",
                         " ", "sellonlatbox", ",", lon1, ",", lon2, ",", lat1, ",", lat2,
                         " ", in_file, 
                         " ", out_file)
      system(cdo_call)
      return(paste0("Done: ", out_file))
    
  }
  
}


# basedata

# f_sellonlat("/mnt/CEPH_BASEDATA/METEO/SCENARIO/SNC/",
#             "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SNC/")
# 
# f_sellonlat("/mnt/CEPH_BASEDATA/METEO/SCENARIO/SND/",
#             "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SND/")
# 
# f_sellonlat("/mnt/CEPH_BASEDATA/METEO/SCENARIO/SNW/",
#             "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SNW/")


# clirsnow


# f_sellonlat("/mnt/CEPH_PROJECTS/CLIRSNOW/wget-snow/SNC/",
#             "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SNC/")

f_sellonlat("/mnt/CEPH_PROJECTS/CLIRSNOW/wget-snow/SND/",
            "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SND/")


f_sellonlat("/mnt/CEPH_PROJECTS/CLIRSNOW/wget-snow/SNW/",
            "/mnt/CEPH_PROJECTS/CLIRSNOW/EUROCORDEX-ALPS/SNW/")


