# compare bc and ds



library(raster)


rr_template <- raster("data/sample_modis_snc_55x133_2000-03-18.tif")


# ensmean bc --------------------------------------------------------------

load("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/bc_full/clim-02.rda")



# only take pixels in common to all RCMs
dat_th <- readRDS("data/auxiliary-02-snow-max-threshold.rds")
dat_th[snow_plausible == "yes" & 
         !rcm_short %in% c("WRF331F", "HIRHAM5", "RACMO22E")] %>% 
  dcast(icell ~ rcm_short, value.var = "snow_plausible") %>% 
  na.omit %>% 
  .[, icell] -> icell_common_rcm
icell_modis <- sort(unique(clim_modis$icell))
icell_common <- intersect(icell_common_rcm, icell_modis)


dt_bc_ens <- clim_qdm[icell %in% icell_common,
                      .(snc_raw = mean(snc),
                        snc_bc = mean(snc_qdm)),
                      .(fp, experiment, icell)]

rr_rcp85 <- raster(rr_template)
rr_rcp85[dt_bc_ens[experiment == "rcp85" & fp == "future", icell]] <- dt_bc_ens[experiment == "rcp85" & fp == "future", snc_bc]

rr_rcp26 <- raster(rr_template)
rr_rcp26[dt_bc_ens[experiment == "rcp26" & fp == "future", icell]] <- dt_bc_ens[experiment == "rcp26" & fp == "future", snc_bc]

plot(rr_rcp85)

# upscale scd -------------------------------------------------------------


rr_scd_rcp26g <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scd_ensemble_mean/rcp26.tif")
rr_scd_rcp26g_lr <- aggregate(rr_scd_rcp26g/365.25, fact = c(37, 53), 
                             fun = mean, na.rm = T)


rr_scd_rcp26 <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scd_ensemble_mean/rcp26_noglacier.tif")
rr_scd_rcp26_lr <- aggregate(rr_scd_rcp26/365.25, fact = c(37, 53), 
                             fun = mean, na.rm = T)
plot(rr_scd_rcp85_lr)

rr_scd_rcp85g <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scd_ensemble_mean/rcp85.tif")
rr_scd_rcp85g_lr <- aggregate(rr_scd_rcp85g/365.25, fact = c(37, 53), 
                              fun = mean, na.rm = T)


rr_scd_rcp85 <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scd_ensemble_mean/rcp85_noglacier.tif")
rr_scd_rcp85_lr <- aggregate(rr_scd_rcp85/365.25, fact = c(37, 53), 
                             fun = mean, na.rm = T)
plot(rr_scd_rcp85_lr)



ggplot()+
  geom_stars(data = st_as_stars(rr_scd_rcp85g_lr - rr_rcp85))+
  scale_fill_gradient2()


ggplot()+
  geom_stars(data = st_as_stars(rr_scd_rcp26g_lr - rr_rcp26))+
  scale_fill_gradient2()




cellStats(rr_scd_rcp85g_lr - rr_rcp85, mean)
cellStats(abs(rr_scd_rcp85g_lr - rr_rcp85), mean)
cellStats(rr_scd_rcp85_lr - rr_rcp85, mean)
cellStats(rr_scd_rcp26_lr - rr_rcp26, mean)
cellStats(rr_scd_rcp26g_lr - rr_rcp26, mean)


cellStats(rr_scd_rcp85_lr - rr_rcp85, mean) * 365.25
cellStats(rr_scd_rcp26_lr - rr_rcp26, mean) * 365.25

# -> ~3.7d bias in DS

# from comp-bc-ds
dat_plot_mmm %>% 
  dcast(fp + experiment + elev ~ ff, value.var = "mod_mean") -> dat_test


dat_test[, 
         .(mean(Downscaling - `Bias correction`, na.rm = T)),
         .(fp, experiment)]