# get icell missing for hi-res scd


library(raster)
library(data.table)
library(magrittr)
library(fs)



# modis -------------------------------------------------------------------


rr_elev <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_altitude_laea.tif")
rr_elev[rr_elev < -30000] <- NA

rr_water <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_water_mask_laea.tif")
rr_elev[rr_water == 1] <- NA

rr_modis <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/clim_SCD/2000-10-01_2019-09-30.tif")


dat_modis <- data.table(icell = 1:ncell(rr_modis),
                        scd = rr_modis[],
                        elev = rr_elev[])
dat_modis[, MODIS := ifelse(!is.na(scd) & !is.na(elev), icell, NA)]



dat_out <- dat_modis[, .(icell, MODIS)]

# rcm ---------------------------------------------------------------------

x <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/03_qdm/"
dat_loop <- data.table(bc_var = path_file(x),
                       file_rcm = dir_ls(x))
    
dat_loop[, c("institute_rcm", "gcm", "experiment", "ensemble", "dsr", "fp") := 
           tstrsplit(path_ext_remove(path_file(file_rcm)), "_")]

dat_loop_rcm <- dat_loop[, .SD[1], .(institute_rcm)]


for(i in seq_len(nrow(dat_loop_rcm))){
  
  i_rcm <- dat_loop_rcm[i, institute_rcm]
  i_fn <- dat_loop_rcm[i, file_rcm]
  
  i_rr <- raster(i_fn)
  dat_out[, c(i_rcm) := ifelse(!is.na(i_rr[]), icell, NA)]
  
}



# check and save ----------------------------------------------------------


# nn_na <- sapply(dat_out, function(x) sum(is.na(x)))
# nn_na - nn_na["MODIS"]
# 
# rr_check <- raster(rr_modis)
# rr_check[] <- dat_out$`CLMcom-CCLM4-8-17`
# rr_check[] <- dat_out$`KNMI-RACMO22E`
# plot(rr_check)


# ~190mb
# saveRDS(dat_out, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/ds/common-icell.rds")


# try to save some space

dat_out2 <- dat_out[, lapply(.SD, function(x) !is.na(x))]
dat_out2[, icell := dat_out$icell]
dat_out2

# ~30mb
saveRDS(dat_out2, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/ds/common-icell.rds")
