# calculate CP for all MODIS data
# TOO MUCH FOR R -> MOVED TO PYTHON


library(fs)
library(data.table)
library(foreach)
library(magrittr)
library(ggplot2)
library(forcats)
library(raster)



# templates
# rr_lr <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/nc_daily/modis_10d/modis_snc_55x133_2000-02-24.tif")
rr_hr <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/05_temporal_complete_max10d/20000224_120000.tif")

# ar_lr <- as.array(rr_lr)
# ar_hr <- as.array(rr_hr)

# settings ----------------------------------------------------------------

# n_bins <- 20 # 5% scf
n_bins <- 10 # 10% scf

# test cut
test_cut <- cut(0:100/100, breaks = seq(0, 1, by = 1/n_bins), include.lowest = T)

files_lr <- dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/nc_daily/modis_10d/") %>% sort
files_hr <- dir_ls("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/05_temporal_complete_max10d/") %>% 
  sort

# ar_cp <- array(NA_integer_, dim = c(nrow(rr_hr), ncol(rr_hr), n_bins))
rr_cp <- brick(rr_hr, values = F, nl = n_bins)
rr_cp <- setValues(rr_cp, 0L)

# loop --------------------------------------------------------------------

stopifnot(length(files_lr) == length(files_hr))
n_files <- length(files_lr)
for(i_fn in 80:n_files){
  
  rr_hr <- raster(files_hr[i_fn])
  rr_lr <- raster(files_lr[i_fn])
  
  rr_lr_bin <- cut(rr_lr, breaks = seq(0, 1, by = 1/n_bins), include.lowest = T)
  
  rr_lr2hr <- resample(rr_lr_bin, rr_hr, method = "ngb")
  rr_lr2hr_brick <- layerize(rr_lr2hr, classes = 1:10)
  
  rr_cp <- rr_cp + rr_lr2hr_brick
  
  cat(format(Sys.time()), ":", i_fn, "of", n_files, "\n")
  
}

# scale to 0-1
rr_cp <- rr_cp/n_files

# saveRDS(levels(test_cut), "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_10bins_levels.rds")

writeRaster(rr_cp, 
            filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_10bins.tif")
