# plot subset of CP

library(raster)
library(mapview)
# library(stars)
# library(sf)
library(data.table)
library(ggplot2)
library(magrittr)


rr_sample <- raster("data/sample_modis_snc_55x133_2000-03-18.tif")
rr0 <- raster(rr_sample)

dat_aux <- readRDS("data/auxiliary-03-modis.rds")

load("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/bc_full/clim-02.rda")

clim_modis_year <- clim_modis[, 
                              .(snc_min = min(snc_min),
                                snc_max = max(snc_max)),
                              .(icell)]

# clim_modis_year %>% merge(dat_aux, by = "icell") %>% 
#   ggplot(aes(x,y,fill = snc_min))+
#   geom_raster()+
#   borders()


rr1 <- rr0
rr1[clim_modis_year$icell] <- clim_modis_year$snc_max
plot(rr1)
mapview(rr1)


clim_qdm_year <- clim_qdm[, 
                          .(snc_qdm_min = min(snc_qdm_min),
                            snc_qdm_max = max(snc_qdm_max)),
                          .(icell, rcm, gcm, experiment, fp)]

clim_qdm_year1 <- clim_qdm_year[fp == "past" & 
                                  rcm == "SMHI-RCA4" & 
                                  gcm == "NCC-NorESM1-M" & 
                                  experiment == "rcp85"]
clim_qdm_year1 <- clim_qdm_year[fp == "future" & 
                                  rcm == "IPSL-WRF381P" & 
                                  gcm == "NCC-NorESM1-M" & 
                                  experiment == "rcp85"]


rr2 <- rr0
rr2[clim_qdm_year1$icell] <- clim_qdm_year1$snc_qdm_max
plot(rr2)
mapview(rr2)
