# calc scf threshold for 01snow based on cp

library(parallel)
library(raster)
# library(stars)
# library(sf)
# library(data.table)
# library(ggplot2)
library(magrittr)

# rr_alt <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_altitude_laea.tif")
# rr_alt[rr_alt < -30000] <- NA

# 20bin
rr_cp <- brick("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp/cp_20bins.tif")
cut(0:100/100, breaks = c(0, 0.001, 1:19/20, 0.999, 1), include.lowest = T) %>% 
  levels -> band_lbl
brks <- c(0, 0.001, 1:19/20, 0.999, 1)
scf_middle <- (head(brks, -1) + tail(brks, -1))/2

source("R/functions/cp50_scf.R")




# calc initial ------------------------------------------------------------



Sys.time()
beginCluster(6)

detach("package:parallel", unload = T, character.only = T)
# detach(package:parallel, unload = T)

rr_scf1 <- clusterR(rr_cp, calc, 
                    args = list(fun = cp50_scf, 
                                filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp/scf_cp50_v02_cluster.tif"),
                    export = c("scf_middle"))

endCluster()

Sys.time()

writeRaster(rr_scf1, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp/scf_cp50_v02_cluster_temp.tif")


