# create rds from rofental data

library(data.table)
library(lubridate)
library(magrittr)
library(raster)
library(foreach)
library(fs)


# approx 80min per 30yr grp and 50min per 20yr grp



paths_in <- dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/test-rofental-cp20/",
                   type = "d")
# paths_in <- paths_in[1:3]

path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/test-rofental-cp20/"




f_read_rofental <- function(path_in){
  
  files <- dir_ls(path_in)
  
  # files <- files[1:20] # test
  
  foreach(
    i_fn = files,
    .final = rbindlist
  ) %do% {
    
    i_fn %>% 
      path_file %>% 
      path_ext_remove %>% 
      ymd -> i_date
    
    rr <- raster(i_fn)
    dt_rr <- data.table(icell = 1:ncell(rr), snc = rr[])
    dt_rr[, date := i_date]
    
    # print(path_file(i_fn)) # verbose
    
    dt_rr
  }
}


mitmatmisc::init_parallel_ubuntu(6)


foreach(
  i_path = paths_in
) %dopar% {
  
  fn_out <- path(path_out, path_file(i_path), ext = "rds")
  dt_rof <- f_read_rofental(i_path)
  saveRDS(dt_rof, fn_out)
  
}