#include <vector>
#include <Rcpp.h>

using namespace std;
typedef int index_type;
// [[Rcpp::export]]

vector<index_type> longest_subseq(SEXP X){
  Rcpp::NumericVector x(X);
  vector<index_type> P(x.size(), 0);
  vector<index_type> M(x.size()+1, 0);
  index_type L(0), newL;
  for(index_type i=0; i < x.size(); ++i) {
    index_type lo(1), hi(L), mid;
    while( lo <= hi) {
      mid = (lo + hi) / 2;
      if (x[M[mid]] <= x[i] ) { //strictly or not monotonic
        lo = mid + 1;
      } else {
        hi = mid - 1;
      }
    }
    newL = lo;
    P[i] = M[newL - 1];
    if (newL > L) {
      M[newL] = i;
      L = newL;
    } else if (x[i] < x[M[newL]]) {
      M[newL] = i;
    }
  }
  vector<index_type> re(L);
  index_type k(M[L]);
  for(index_type i=L-1; i>=0; --i){
    re[i] = k + 1;
    k = P[k];
  }
  return(re);
}
